var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.PIPES=void 0;

var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _common=require("../common");









var _prompt=require("../systemTools/prompt");
var _constants=require("../constants");


















var _apple=require("../platformTools/apple");
var _android=require("../platformTools/android");
var _tizen=require("../platformTools/tizen");
var _webos=require("../platformTools/webos");
var _electron=require("../platformTools/electron");
var _firefox=require("../platformTools/firefox");
var _web=require("../platformTools/web");
var _templateTools=require("../templateTools");
var _fileutils=require("../systemTools/fileutils");
var _platform=_interopRequireDefault(require("./platform"));
var _buildHooks=require("../projectTools/buildHooks");
var _logger=require("../systemTools/logger");
var _projectParser=require("../projectTools/projectParser");




var CONFIGURE='configure';
var SWITCH='switch';
var CREATE='create';
var NEW='new';

var PIPES={
APP_CONFIGURE_BEFORE:'configure:before',
APP_CONFIGURE_AFTER:'configure:after',
APP_SWITCH_BEFORE:'switch:before',
APP_SWITCH_AFTER:'switch:after'};exports.PIPES=PIPES;


var highlight=_chalk.default.green;





var run=function run(c){
(0,_common.logTask)('run');

switch(c.command){
case NEW:
return _runCreate(c);
case CONFIGURE:
return _runConfigure(c);
case SWITCH:
return _runSwitch(c);}


switch(c.subCommand){
case CONFIGURE:
(0,_common.logWarning)("$ "+_chalk.default.red('$ rnv app configure')+" is deprecated. Use "+_chalk.default.green('$ rnv configure')+" instead");
return _runConfigure(c);














default:
return Promise.reject("cli:app: Sub-Command "+c.subCommand+" not supported");}

};





var _runConfigure=function _runConfigure(c){return new Promise(function(resolve,reject){
var p=c.program.platform||'all';
(0,_common.logTask)("_runConfigure:"+p);

(0,_buildHooks.executePipe)(c,PIPES.APP_CONFIGURE_BEFORE).
then(function(){return _checkAndCreatePlatforms(c,c.program.platform);}).
then(function(){return(0,_projectParser.copyRuntimeAssets)(c);}).
then(function(){return(0,_projectParser.copySharedPlatforms)(c);}).
then(function(){return _runPlugins(c,c.paths.rnv.plugins.dir);}).
then(function(){return _runPlugins(c,c.paths.project.projectConfig.pluginsDir);}).
then(function(){return _isOK(c,p,[_constants.ANDROID])?(0,_android.configureGradleProject)(c,_constants.ANDROID):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.ANDROID_TV])?(0,_android.configureGradleProject)(c,_constants.ANDROID_TV):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.ANDROID_WEAR])?(0,_android.configureGradleProject)(c,_constants.ANDROID_WEAR):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN])?(0,_tizen.configureTizenGlobal)(c,_constants.TIZEN):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN])?(0,_tizen.configureTizenProject)(c,_constants.TIZEN):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN_WATCH])?(0,_tizen.configureTizenProject)(c,_constants.TIZEN_WATCH):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TIZEN_MOBILE])?(0,_tizen.configureTizenProject)(c,_constants.TIZEN_MOBILE):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.WEBOS])?(0,_webos.configureWebOSProject)(c,_constants.WEBOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.WEB])?(0,_web.configureWebProject)(c,_constants.WEB):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.MACOS])?(0,_electron.configureElectronProject)(c,_constants.MACOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.WINDOWS])?(0,_electron.configureElectronProject)(c,_constants.WINDOWS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.KAIOS])?(0,_firefox.configureKaiOSProject)(c,_constants.KAIOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.FIREFOX_OS])?(0,_firefox.configureKaiOSProject)(c,_constants.FIREFOX_OS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.FIREFOX_TV])?(0,_firefox.configureKaiOSProject)(c,_constants.FIREFOX_TV):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.IOS])?(0,_apple.configureXcodeProject)(c,_constants.IOS):Promise.resolve();}).
then(function(){return _isOK(c,p,[_constants.TVOS])?(0,_apple.configureXcodeProject)(c,_constants.TVOS):Promise.resolve();}).
then(function(){return(0,_buildHooks.executePipe)(c,PIPES.APP_CONFIGURE_AFTER);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};

var _runSwitch=function _runSwitch(c){return new Promise(function(resolve,reject){
var p=c.program.platform||'all';
(0,_common.logTask)("_runSwitch:"+p);

(0,_buildHooks.executePipe)(c,PIPES.APP_SWITCH_AFTER).

then(function(){return(0,_projectParser.copyRuntimeAssets)(c);}).
then(function(){return(0,_projectParser.copySharedPlatforms)(c);}).
then(function(){return(0,_buildHooks.executePipe)(c,PIPES.APP_SWITCH_AFTER);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};

var _isOK=function _isOK(c,p,list){
var result=false;
list.forEach(function(v){
if((0,_common.isPlatformActive)(c,v)&&(p===v||p==='all'))result=true;
});
return result;
};

var _runCreate=function _runCreate(c){return new Promise(function(resolve,reject){
(0,_common.logTask)('_runCreate');

var data={
defaultVersion:'0.1.0',
defaultTemplate:'renative-template-hello-world',
defaultProjectName:'helloRenative',
defaultAppTitle:'Hello Renative'};

data.optionPlatforms=(0,_prompt.generateOptions)(_constants.SUPPORTED_PLATFORMS,true);
data.optionTemplates=(0,_templateTools.getTemplateOptions)();



(0,_prompt.askQuestion)("What's your project Name? (no spaces, folder based on ID will be created in this directory)",data,'inputProjectName').
then(function(){return(0,_prompt.askQuestion)("What's your project Title? (press ENTER to use default: "+highlight(data.defaultAppTitle)+")",data,'inputAppTitle');}).
then(function(){data.appID="com.mycompany."+data.inputProjectName.replace(/\s+/g,'').toLowerCase();}).
then(function(){return(0,_prompt.askQuestion)("What's your App ID? (press ENTER to use default: "+highlight(data.appID)+")",data,'inputAppID');}).
then(function(){return(0,_prompt.askQuestion)("What's your Version? (press ENTER to use default: "+highlight(data.defaultVersion)+")",data,'inputVersion');}).
then(function(){return(0,_prompt.askQuestion)("What template to use? (press ENTER to use default: "+highlight(data.defaultTemplate)+")\n"+data.optionTemplates.asString+")",
data,'inputTemplate');}).
then(function(){return data.optionTemplates.pick(data.inputTemplate,data.defaultTemplate);}).
then(function(){return(0,_prompt.askQuestion)("What platforms would you like to use? (Add numbers separated by comma or leave blank for all)\n"+
data.optionPlatforms.asString,data,'inputSupportedPlatforms');}).
then(function(){return data.optionPlatforms.pick(data.inputSupportedPlatforms);}).
then(function(){return _prepareProjectOverview(c,data);}).
then(function(){return(0,_prompt.askQuestion)("Is All Correct? (press ENTER for yes)\n"+data.confirmString);}).
then(function(){return _generateProject(c,data);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};

var _generateProject=function _generateProject(c,data){return new Promise(function(resolve,reject){
(0,_prompt.finishQuestion)();


var base=_path.default.resolve('.');

c.paths.project.dir=_path.default.join(base,data.projectName.replace(/(\s+)/g,'_'));
c.paths.project.package=_path.default.join(c.paths.project.dir,'package.json');

data.packageName=data.appTitle.replace(/\s+/g,'-').toLowerCase();

(0,_fileutils.mkdirSync)(c.paths.project.dir);

(0,_common.logSuccess)("Your project is ready! navigate to project "+
_chalk.default.white("cd "+data.projectName)+" and run "+_chalk.default.white(
'rnv run -p web')+" to see magic happen!");



resolve();
});};

var _prepareProjectOverview=function _prepareProjectOverview(c,data){return new Promise(function(resolve,reject){
data.projectName=data.inputProjectName;
data.appTitle=data.inputAppTitle||data.defaultAppTitle;
data.teamID='';
data.appID=data.inputAppID?data.inputAppID.replace(/\s+/g,'-').toLowerCase():data.appID;
data.version=data.inputVersion||data.defaultVersion;

var str=(0,_logger.printBoxStart)('🚀  ReNative Project Generator');
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)("Project Name (folder): "+highlight(data.projectName),1);
str+=(0,_logger.printIntoBox)("Project Title: "+highlight(data.appTitle),1);
str+=(0,_logger.printIntoBox)("Project Version: "+highlight(data.version),1);
str+=(0,_logger.printIntoBox)("App ID: "+highlight(data.appID),1);
str+=(0,_logger.printIntoBox)("Project Template: "+highlight(data.optionTemplates.selectedOption),1);
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)('Project Platforms:');
str+=(0,_logger.printArrIntoBox)(data.optionPlatforms.selectedOptions);
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)('Project Structure:');
str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printIntoBox)(data.projectName);
str+=_chalk.default.gray("\u2502   \u251C\u2500\u2500 appConfigs           # Application flavour configuration files/assets  \u2502\n\u2502   \u2502   \u2514\u2500\u2500 default          # Example application flavour                     \u2502\n\u2502   \u2502       \u251C\u2500\u2500 assets       # Platform assets injected to ./platformAssets    \u2502\n\u2502   \u2502       \u251C\u2500\u2500 builds       # Platform files injected to ./platformBuilds     \u2502\n\u2502   \u2502       \u2514\u2500\u2500 renative.json  # Application flavour config                      \u2502\n\u2502   \u251C\u2500\u2500 platformAssets       # Generated cross-platform assets                 \u2502\n\u2502   \u251C\u2500\u2500 platformBuilds       # Generated platform app projects                 \u2502\n\u2502   \u251C\u2500\u2500 projectConfigs       # Project configuration files/assets              \u2502\n\u2502   \u2502   \u251C\u2500\u2500 fonts            # Folder for all custom fonts                     \u2502\n\u2502   \u2502   \u251C\u2500\u2500 permissions.json # Permissions configuration                       \u2502\n\u2502   \u2502   \u2514\u2500\u2500 plugins.json     # Multi-platform Plugins configuration            \u2502\n\u2502   \u251C\u2500\u2500 src                  # Source files                                    \u2502\n\u2502   \u251C\u2500\u2500 index.*.js           # Entry files                                     \u2502\n\u2502   \u2514\u2500\u2500 renative.json      # ReNative project configuration                  \u2502\n");














str+=(0,_logger.printIntoBox)('');
str+=(0,_logger.printBoxEnd)();
str+='\n';

data.confirmString=str;
resolve();
});};

var _checkAndCreatePlatforms=function _checkAndCreatePlatforms(c,platform){return new Promise(function(resolve,reject){
(0,_common.logTask)("_checkAndCreatePlatforms:"+platform);

if(!_fs.default.existsSync(c.paths.project.builds.dir)){
(0,_common.logWarning)('Platforms not created yet. creating them for you...');
(0,_platform.default)((0,_common.spawnCommand)(c,{
subCommand:'configure',
program:{appConfig:c.runtime.appId,platform:platform}})).

then(function(){return resolve();}).
catch(function(e){return reject(e);});

return;
}
if(platform){
var appFolder=(0,_common.getAppFolder)(c,platform);
if(!_fs.default.existsSync(appFolder)){
(0,_common.logWarning)("Platform "+platform+" not created yet. creating them for you...");
(0,_platform.default)((0,_common.spawnCommand)(c,{
subCommand:'configure',
program:{appConfig:c.runtime.appId,platform:platform}})).

then(function(){return resolve();}).
catch(function(e){return reject(e);});

return;
}
}else{var
platforms=c.buildConfig.platforms;
var cmds=[];
if(!platforms){
reject("Your "+_chalk.default.white(c.paths.appConfig.config)+" is missconfigured. (Maybe you have older version?). Missing "+_chalk.default.white('{ platforms: {} }')+" object at root");
return;
}

Object.keys(platforms).forEach(function(k){
if(!_fs.default.existsSync(k)){
(0,_common.logWarning)("Platform "+k+" not created yet. creating one for you...");
cmds.push((0,_platform.default)((0,_common.spawnCommand)(c,{
subCommand:'configure',
program:{appConfig:c.runtime.appId,platform:platform}})));

}
});

Promise.all(cmds).
then(function(){return resolve();}).
catch(function(e){return reject(e);});

return;
}
resolve();
});};

var _runPlugins=function _runPlugins(c,pluginsPath){return new Promise(function(resolve){
(0,_common.logTask)("_runPlugins:"+pluginsPath,_chalk.default.grey);

if(!_fs.default.existsSync(pluginsPath)){
(0,_common.logInfo)("Your project plugin folder "+_chalk.default.white(pluginsPath)+" does not exists. skipping plugin configuration");
resolve();
return;
}

_fs.default.readdirSync(pluginsPath).forEach(function(dir){
var source=_path.default.resolve(pluginsPath,dir,'overrides');
var dest=_path.default.resolve(c.paths.project.dir,'node_modules',dir);

if(_fs.default.existsSync(source)){
(0,_fileutils.copyFolderContentsRecursiveSync)(source,dest,false);



}else{
(0,_common.logInfo)("Your plugin configuration has no override path "+_chalk.default.white(source)+". skipping override action");
}
});

resolve();
});};var _default=



run;exports.default=_default;