var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.configureRnvGlobal=exports.listAppConfigsFoldersSync=exports.updateConfig=exports.setAppConfig=exports.loadFile=exports.fixRenativeConfigsSync=exports.checkIsRenativeProject=exports.parseRenativeConfigs=exports.createRnvConfig=void 0;var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _toConsumableArray2=_interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _deepmerge=_interopRequireDefault(require("deepmerge"));
var _constants=require("../constants");
















































var _fileutils=require("../systemTools/fileutils");




var _logger=require("../systemTools/logger");




var _prompt=require("../systemTools/prompt");
var _projectParser=require("../projectTools/projectParser");function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(source,true).forEach(function(key){(0,_defineProperty2.default)(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(source).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}





var base=_path.default.resolve('.');
var homedir=require('os').homedir();

var IGNORE_FOLDERS=['.git'];

var createRnvConfig=function createRnvConfig(program,process,cmd,subCmd){
var c={
cli:{},
runtime:{},


paths:{
buildHooks:{
dist:{}},

home:{},
rnv:{
pluginTemplates:{},
platformTemplates:{},
plugins:{},
projectTemplate:{}},

global:{},


project:{
projectConfig:{},
builds:{},
assets:{},
platformTemplates:{}},

appConfig:{},
private:{
project:{
projectConfig:{},
builds:{},
assets:{},
platformTemplates:{}},

appConfig:{}}},


files:{
rnv:{
pluginTemplates:{},
platformTemplates:{},
plugins:{},
projectTemplate:{}},

global:{},
project:{
projectConfig:{},
builds:{},
assets:{},
platformTemplates:{}},

appConfig:{},
private:{
project:{
projectConfig:{},
builds:{},
assets:{},
platformTemplates:{}},

appConfig:{}}}};




c.program=program;
c.process=process;
c.command=cmd;
c.subCommand=subCmd;
c.platformDefaults=_constants.PLATFORMS;

c.paths.rnv.dir=_path.default.join(__dirname,'../..');
c.paths.rnv.nodeModulesDir=_path.default.join(c.paths.rnv.dir,'node_modules');
c.paths.rnv.platformTemplates.dir=_path.default.join(c.paths.rnv.dir,'platformTemplates');
c.paths.rnv.pluginTemplates.dir=_path.default.join(c.paths.rnv.dir,'pluginTemplates');
c.paths.rnv.pluginTemplates.config=_path.default.join(c.paths.rnv.pluginTemplates.dir,'plugins.json');
c.paths.rnv.package=_path.default.join(c.paths.rnv.dir,'package.json');
c.paths.rnv.plugins.dir=_path.default.join(c.paths.rnv.dir,'plugins');
c.paths.rnv.projectTemplate.dir=_path.default.join(c.paths.rnv.dir,'projectTemplate');
c.files.rnv.package=JSON.parse(_fs.default.readFileSync(c.paths.rnv.package).toString());

c.platform=c.program.platform;
c.runtime.platform=c.platform;
c.paths.home.dir=homedir;
c.paths.GLOBAL_RNV_DIR=_path.default.join(c.paths.home.dir,'.rnv');
c.paths.GLOBAL_RNV_CONFIG=_path.default.join(c.paths.GLOBAL_RNV_DIR,_constants.RENATIVE_CONFIG_NAME);

_generateConfigPaths(c.paths.project,base);

c.paths.buildHooks.dir=_path.default.join(c.paths.project.dir,'buildHooks/src');
c.paths.buildHooks.dist.dir=_path.default.join(c.paths.project.dir,'buildHooks/dist');
c.paths.buildHooks.index=_path.default.join(c.paths.buildHooks.dir,'index.js');
c.paths.buildHooks.dist.index=_path.default.join(c.paths.buildHooks.dist.dir,'index.js');
c.paths.project.nodeModulesDir=_path.default.join(c.paths.project.dir,'node_modules');
c.paths.project.srcDir=_path.default.join(c.paths.project.dir,'src');
c.paths.project.appConfigsDir=_path.default.join(c.paths.project.dir,'appConfigs');
c.paths.project.package=_path.default.join(c.paths.project.dir,'package.json');
c.paths.project.rnCliConfig=_path.default.join(c.paths.project.dir,_constants.RN_CLI_CONFIG_NAME);
c.paths.project.babelConfig=_path.default.join(c.paths.project.dir,_constants.RN_BABEL_CONFIG_NAME);
c.paths.project.npmLinkPolyfill=_path.default.join(c.paths.project.dir,'npm_link_polyfill.json');
c.paths.project.projectConfig.dir=_path.default.join(c.paths.project.dir,'projectConfig');
c.paths.project.projectConfig.pluginsDir=_path.default.join(c.paths.project.projectConfig.dir,'plugins');
c.paths.project.projectConfig.fontsDir=_path.default.join(c.paths.project.projectConfig.dir,'fonts');
c.paths.project.assets.dir=_path.default.join(c.paths.project.dir,'platformAssets');
c.paths.project.assets.config=_path.default.join(c.paths.project.assets.dir,_constants.RENATIVE_CONFIG_RUNTIME_NAME);
c.paths.project.builds.dir=_path.default.join(c.paths.project.dir,'platformBuilds');
c.paths.project.builds.config=_path.default.join(c.paths.project.builds.dir,_constants.RENATIVE_CONFIG_BUILD_NAME);

_generateConfigPaths(c.paths.private,c.paths.GLOBAL_RNV_DIR);

c.files.rnv.pluginTemplates.config=JSON.parse(_fs.default.readFileSync(_path.default.join(c.paths.rnv.pluginTemplates.config)).toString());

return c;
};exports.createRnvConfig=createRnvConfig;

var parseRenativeConfigs=function parseRenativeConfigs(c){return new Promise(function(resolve,reject){var _c$files$project,_c$files$project$conf,_c$files$project$conf2,_c$buildConfig$paths,_c$buildConfig$paths$,_c$buildConfig$paths2;

if(!loadFile(c.files.project.builds,c.paths.project.builds,'config'));


_generateConfigPaths(c.paths.private,c.paths.GLOBAL_RNV_DIR);


_loadConfigFiles(c,c.files.project,c.paths.project);
c.runtime.appId=c.program.appConfigID||((_c$files$project=c.files.project)==null?void 0:(_c$files$project$conf=_c$files$project.configLocal)==null?void 0:(_c$files$project$conf2=_c$files$project$conf._meta)==null?void 0:_c$files$project$conf2.currentAppConfigId);
console.log('AGAGAGAGA',c.runtime.appId);
if(!c.files.project.config)return resolve();


_generateConfigPaths(c.paths.private,(0,_fileutils.getRealPath)(c,(_c$buildConfig$paths=c.buildConfig.paths)==null?void 0:(_c$buildConfig$paths$=_c$buildConfig$paths.private)==null?void 0:_c$buildConfig$paths$.dir)||c.paths.GLOBAL_RNV_DIR);
_generateConfigPaths(c.paths.private.project,_path.default.join(c.paths.GLOBAL_RNV_DIR,c.files.project.config.projectName));
_loadConfigFiles(c,c.files.private.project,c.paths.private.project);


c.paths.private.project.projectConfig.dir=_path.default.join(c.paths.private.project.dir,'projectConfig');
c.paths.private.project.appConfigsDir=_path.default.join(c.paths.private.project.dir,'appConfigs');
c.paths.project.appConfigsDir=(0,_fileutils.getRealPath)(c,(_c$buildConfig$paths2=c.buildConfig.paths)==null?void 0:_c$buildConfig$paths2.appConfigsDir,'appConfigsDir',c.paths.project.appConfigsDir);
c.runtime.isWrapper=c.buildConfig.isWrapper;

c.paths.project.platformTemplatesDirs=_generatePlatformTemplatePaths(c);

resolve();
});};exports.parseRenativeConfigs=parseRenativeConfigs;

var checkIsRenativeProject=function checkIsRenativeProject(c){return new Promise(function(resolve,reject){
if(!c.paths.project.configExists){
return reject("Looks like this directory is not ReNative project. Project config "+
_chalk.default.white(
c.paths.project.config)+" is missing!. You can create new project with "+
_chalk.default.white('rnv new'));

}

return resolve();
});};exports.checkIsRenativeProject=checkIsRenativeProject;

var fixRenativeConfigsSync=function fixRenativeConfigsSync(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('fixRenativeConfigsSync');





(0,_projectParser.checkAndCreateGitignore)(c);


(0,_logger.logTask)('configureProject:check rn-cli',_chalk.default.grey);
if(!_fs.default.existsSync(c.paths.project.rnCliConfig)){
(0,_logger.logInfo)("Looks like your rn-cli config file "+
_chalk.default.white(c.paths.project.rnCliConfig)+" is missing! Let's create one for you.");

(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnv.projectTemplate.dir,_constants.RN_CLI_CONFIG_NAME),c.paths.project.rnCliConfig);
}


(0,_logger.logTask)('configureProject:check babel config',_chalk.default.grey);
if(!_fs.default.existsSync(c.paths.project.babelConfig)){
(0,_logger.logInfo)("Looks like your babel config file "+
_chalk.default.white(c.paths.project.babelConfig)+" is missing! Let's create one for you.");

(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnv.dir,_constants.RN_BABEL_CONFIG_NAME),c.paths.project.babelConfig);
}

resolve();
});};exports.fixRenativeConfigsSync=fixRenativeConfigsSync;

var _generateConfigPaths=function _generateConfigPaths(pathObj,dir){
pathObj.dir=dir;
pathObj.config=_path.default.join(dir,_constants.RENATIVE_CONFIG_NAME);
pathObj.configLocal=_path.default.join(dir,_constants.RENATIVE_CONFIG_LOCAL_NAME);
pathObj.configPrivate=_path.default.join(dir,_constants.RENATIVE_CONFIG_PRIVATE_NAME);
};

var _versionCheck=function _versionCheck(c){var _c$files$rnv,_c$files$rnv$package,_c$files$project2,_c$files$project2$pac,_c$files$project2$pac2;
(0,_logger.logTask)('_versionCheck');
c.runtime.rnvVersionProject=(_c$files$rnv=c.files.rnv)==null?void 0:(_c$files$rnv$package=_c$files$rnv.package)==null?void 0:_c$files$rnv$package.version;
c.runtime.rnvVersionRunner=(_c$files$project2=c.files.project)==null?void 0:(_c$files$project2$pac=_c$files$project2.package)==null?void 0:(_c$files$project2$pac2=_c$files$project2$pac.devDependencies)==null?void 0:_c$files$project2$pac2.rnv;
if(c.runtime.rnvVersionRunner&&c.runtime.rnvVersionProject){
if(c.runtime.rnvVersionRunner!==c.runtime.rnvVersionProject){
var recCmd=_chalk.default.white("$ npx "+(0,_logger.getCurrentCommand)(true));
(0,_logger.logWarning)("You are running $rnv v"+_chalk.default.red(c.runtime.rnvVersionRunner)+" against project built with $rnv v"+_chalk.default.red(c.runtime.rnvVersionProject)+".\nThis might result in unexpected behaviour! It is recommended that you run your rnv command with npx prefix: "+
recCmd+" .");
}
}
};

var loadFile=function loadFile(fileObj,pathObj,key){
if(!_fs.default.existsSync(pathObj[key])){
pathObj[key+"Exists"]=false;
(0,_logger.logDebug)("WARNING: loadFile: Path "+pathObj[key]+" does not exists!");
return false;
}
pathObj[key+"Exists"]=true;
try{
fileObj[key]=JSON.parse(_fs.default.readFileSync(pathObj[key]).toString());
pathObj[key+"Exists"]=true;
return true;
}catch(e){
(0,_logger.logError)("loadFile: "+pathObj[key]+" :: "+e);
return false;
}
};exports.loadFile=loadFile;

var _loadConfigFiles=function _loadConfigFiles(c,fileObj,pathObj,extendDir){
var result=false;
var extendAppId;
if(loadFile(fileObj,pathObj,'config')){
extendAppId=fileObj.config.extend||extendAppId;
result=true;
}

if(loadFile(fileObj,pathObj,'configLocal')){
extendAppId=fileObj.configLocal.extend||extendAppId;
result=true;
}

if(loadFile(fileObj,pathObj,'configPrivate')){
extendAppId=fileObj.configPrivate.extend||extendAppId;
result=true;
}

if(extendAppId&&extendDir){
pathObj.configBase=_path.default.join(extendDir,extendAppId,'renative.json');
pathObj.dirs=[
_path.default.join(extendDir,extendAppId),
pathObj.dir];

loadFile(fileObj,pathObj,'configBase');
}

_generateBuildConfig(c);
return result;
};


var setAppConfig=function setAppConfig(c,appId){
(0,_logger.logTask)("setAppConfig:"+appId);

if(!appId)return;

c.runtime.appId=appId;
c.runtime.appDir=_path.default.join(c.paths.project.builds.dir,c.runtime.appId+"_"+c.runtime.platform);

_generateConfigPaths(c.paths.appConfig,_path.default.join(c.paths.project.appConfigsDir,appId));
_loadConfigFiles(c,c.files.appConfig,c.paths.appConfig,c.paths.project.appConfigsDir);

_generateConfigPaths(c.paths.private.appConfig,_path.default.join(c.paths.private.project.appConfigsDir,appId));
_loadConfigFiles(c,c.files.private.appConfig,c.paths.private.appConfig,c.paths.private.project.appConfigsDir);

_generateBuildConfig(c);
_generateLocalConfig(c);
};exports.setAppConfig=setAppConfig;

var _arrayMergeOverride=function _arrayMergeOverride(destinationArray,sourceArray,mergeOptions){return sourceArray;};

var _generateBuildConfig=function _generateBuildConfig(c){
(0,_logger.logTask)('_generateBuildConfig');

var mergeOrder=[
c.paths.project.config,
c.paths.project.configPrivate,
c.paths.project.configLocal,
c.paths.private.project.config,
c.paths.private.project.configPrivate,
c.paths.private.project.configLocal,
c.paths.appConfig.configBase,
c.paths.appConfig.config,
c.paths.appConfig.configPrivate,
c.paths.appConfig.configLocal,
c.paths.private.appConfig.configBase,
c.paths.private.appConfig.config,
c.paths.private.appConfig.configPrivate,
c.paths.private.appConfig.configLocal];

var cleanPaths=mergeOrder.filter(function(v){return v;});
var existsPaths=cleanPaths.filter(function(v){
var exists=_fs.default.existsSync(v);
if(exists){
console.log("Merged: "+v);

}else{

}
return exists;
});

var mergeFiles=[
c.files.project.config,
c.files.project.configPrivate,
c.files.project.configLocal,
c.files.private.project.config,
c.files.private.project.configPrivate,
c.files.private.project.configLocal,
c.files.appConfig.configBase,
c.files.appConfig.config,
c.files.appConfig.configPrivate,
c.files.appConfig.configLocal,
c.files.private.appConfig.configBase,
c.files.private.appConfig.config,
c.files.private.appConfig.configPrivate,
c.files.private.appConfig.configLocal];




var mergeFolders=[];






var meta=[{
_meta:{
generated:new Date().getTime(),
mergedConfigs:existsPaths}}];



var existsFiles=mergeFiles.filter(function(v,i){return v;});

(0,_logger.logTask)("_generateBuildConfig:"+mergeOrder.length+":"+cleanPaths.length+":"+existsPaths.length+":"+existsFiles.length,_chalk.default.grey);

var out=_deepmerge.default.all([].concat(meta,(0,_toConsumableArray2.default)(existsFiles)),{arrayMerge:_arrayMergeOverride});
c.buildConfig=out;
if(_fs.default.existsSync(c.paths.project.builds.dir)){
(0,_fileutils.writeObjectSync)(c.paths.project.builds.config,c.buildConfig);
}

c.assetConfig={
common:c.buildConfig.common};


if(_fs.default.existsSync(c.paths.project.assets.dir)){
(0,_fileutils.writeObjectSync)(c.paths.project.assets.config,c.assetConfig);
}
};

var _generateLocalConfig=function _generateLocalConfig(c){
var configLocal=c.files.project.configLocal||{};
configLocal._meta=configLocal._meta||{};
configLocal._meta.currentAppConfigId=c.runtime.appId;
c.files.project.configLocal=configLocal;
(0,_fileutils.writeObjectSync)(c.paths.project.configLocal,configLocal);
};

var _generatePlatformTemplatePaths=function _generatePlatformTemplatePaths(c){
var pt=c.buildConfig.platformTemplatesFolders||{};
var originalPath=c.buildConfig.platformTemplatesFolder||'RNV_HOME/platformTemplates';
var result={};
_constants.SUPPORTED_PLATFORMS.forEach(function(v){
if(!pt[v]){
result[v]=(0,_fileutils.getRealPath)(
c,
originalPath,
'platformTemplatesFolder',
originalPath);

}else{
result[v]=(0,_fileutils.getRealPath)(
c,
pt[v],
'platformTemplatesFolder',
originalPath);

}
});
return result;
};

var updateConfig=function updateConfig(c,appConfigId){return new Promise(function(resolve,reject){
(0,_logger.logTask)("updateConfig:"+appConfigId);

setAppConfig(c,appConfigId);

if(!_fs.default.existsSync(c.paths.appConfig.dir)){
var readline=require('readline').createInterface({
input:process.stdin,
output:process.stdout});


var configDirs=listAppConfigsFoldersSync(c);


if(appConfigId!=='?'){
(0,_logger.logWarning)("It seems you don't have appConfig named "+
_chalk.default.white(appConfigId)+" present in your config folder: "+_chalk.default.white(
c.paths.project.appConfigsDir)+" !");


}

if(configDirs.length){
var opts='';
configDirs.forEach(function(v,i){
opts+="("+_chalk.default.white(i)+") "+_chalk.default.white(v)+"\n";
});

readline.question(
(0,_prompt.getQuestion)("ReNative found existing appConfigs. which one would you like to pick (pick number)?:\n"+opts),
function(v){
if(configDirs[v]){
setAppConfig(c,configDirs[v]);
resolve();
}else{
reject('Wrong option!');
}
});

}else{
readline.question(
(0,_prompt.getQuestion)("Do you want ReNative to create new sample appConfig ("+
_chalk.default.white(
appConfigId)+") for you? (y) to confirm"),


function(v){
setAppConfig(c,_constants.SAMPLE_APP_ID);
(0,_fileutils.copyFolderContentsRecursiveSync)(
_path.default.join(c.paths.rnv.dir,'appConfigs',_constants.SAMPLE_APP_ID),
_path.default.join(c.paths.appConfig.dir));

resolve();
});

}
}else{
resolve();
}
});};exports.updateConfig=updateConfig;

var listAppConfigsFoldersSync=function listAppConfigsFoldersSync(c){
var configDirs=[];
_fs.default.readdirSync(c.paths.project.appConfigsDir).forEach(function(dir){
if(!IGNORE_FOLDERS.includes(dir)&&_fs.default.lstatSync(_path.default.join(c.paths.project.appConfigsDir,dir)).isDirectory()){
configDirs.push(dir);
}
});
return configDirs;
};exports.listAppConfigsFoldersSync=listAppConfigsFoldersSync;

var configureRnvGlobal=function configureRnvGlobal(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('configureRnvGlobal');

if(_fs.default.existsSync(c.paths.GLOBAL_RNV_DIR)){
console.log(c.paths.GLOBAL_RNV_DIR+" folder exists!");
}else{
console.log(c.paths.GLOBAL_RNV_DIR+" folder missing! Creating one for you...");
(0,_fileutils.mkdirSync)(c.paths.GLOBAL_RNV_DIR);
}


if(_fs.default.existsSync(c.paths.GLOBAL_RNV_CONFIG)){
console.log(c.paths.GLOBAL_RNV_DIR+"/"+_constants.RENATIVE_CONFIG_NAME+" file exists!");
}else{
var oldGlobalConfigPath=_path.default.join(c.paths.GLOBAL_RNV_DIR,'config.json');
if(_fs.default.existsSync(oldGlobalConfigPath)){
(0,_logger.logWarning)('Found old version of your config. will copy it to new renative.json config');
(0,_fileutils.copyFileSync)(oldGlobalConfigPath,c.paths.GLOBAL_RNV_CONFIG);
}else{
console.log(c.paths.GLOBAL_RNV_DIR+"/"+_constants.RENATIVE_CONFIG_NAME+" file missing! Creating one for you...");
(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnv.dir,'supportFiles','global-config-template.json'),c.paths.GLOBAL_RNV_CONFIG);
console.log("Don't forget to Edit: "+

c.paths.GLOBAL_RNV_DIR+"/"+
_constants.RENATIVE_CONFIG_NAME+" with correct paths to your SDKs before continuing!");

}
}

if(_fs.default.existsSync(c.paths.GLOBAL_RNV_CONFIG)){
c.files.GLOBAL_RNV_CONFIG=JSON.parse(_fs.default.readFileSync(c.paths.GLOBAL_RNV_CONFIG).toString());

if(c.files.GLOBAL_RNV_CONFIG.appConfigsPath){
if(!_fs.default.existsSync(c.files.GLOBAL_RNV_CONFIG.appConfigsPath)){
(0,_logger.logWarning)("Looks like your custom global appConfig is pointing to "+
_chalk.default.white(
c.files.GLOBAL_RNV_CONFIG.appConfigsPath)+" which doesn't exist! Make sure you create one in that location");


}else{
(0,_logger.logInfo)("Found custom appConfing location pointing to "+
_chalk.default.white(
c.files.GLOBAL_RNV_CONFIG.appConfigsPath)+". ReNativewill now swith to that location!");


c.paths.project.appConfigsDir=c.files.GLOBAL_RNV_CONFIG.appConfigsPath;
}
}

var isRunningOnWindows=process.platform==='win32';var


sdks=c.files.GLOBAL_RNV_CONFIG.sdks;
if(sdks){
if(sdks.ANDROID_SDK){
c.cli[_constants.CLI_ANDROID_EMULATOR]=_path.default.join(sdks.ANDROID_SDK,"emulator/emulator"+(isRunningOnWindows?'.exe':''));
c.cli[_constants.CLI_ANDROID_ADB]=_path.default.join(sdks.ANDROID_SDK,"platform-tools/adb"+(isRunningOnWindows?'.exe':''));
c.cli[_constants.CLI_ANDROID_AVDMANAGER]=_path.default.join(sdks.ANDROID_SDK,"tools/bin/avdmanager"+(isRunningOnWindows?'.bat':''));
c.cli[_constants.CLI_ANDROID_SDKMANAGER]=_path.default.join(sdks.ANDROID_SDK,"tools/bin/sdkmanager"+(isRunningOnWindows?'.bat':''));
}
if(sdks.TIZEN_SDK){
c.cli[_constants.CLI_TIZEN_EMULATOR]=_path.default.join(sdks.TIZEN_SDK,"tools/emulator/bin/em-cli"+(isRunningOnWindows?'.bat':''));
c.cli[_constants.CLI_TIZEN]=_path.default.join(sdks.TIZEN_SDK,"tools/ide/bin/tizen"+(isRunningOnWindows?'.bat':''));
c.cli[_constants.CLI_SDB_TIZEN]=_path.default.join(sdks.TIZEN_SDK,'tools/sdb');
}
if(sdks.WEBOS_SDK){
c.cli[_constants.CLI_WEBOS_ARES]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares"+(isRunningOnWindows?'.cmd':''));
c.cli[_constants.CLI_WEBOS_ARES_PACKAGE]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares-package"+(isRunningOnWindows?'.cmd':''));
c.cli[_constants.CLI_WEBOS_ARES_INSTALL]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares-install"+(isRunningOnWindows?'.cmd':''));
c.cli[_constants.CLI_WEBOS_ARES_LAUNCH]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares-launch"+(isRunningOnWindows?'.cmd':''));
c.cli[_constants.CLI_WEBOS_ARES_SETUP_DEVICE]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares-setup-device"+(isRunningOnWindows?'.cmd':''));
c.cli[_constants.CLI_WEBOS_ARES_DEVICE_INFO]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares-device-info"+(isRunningOnWindows?'.cmd':''));
c.cli[_constants.CLI_WEBOS_ARES_NOVACOM]=_path.default.join(c.files.GLOBAL_RNV_CONFIG.sdks.WEBOS_SDK,"CLI/bin/ares-novacom"+(isRunningOnWindows?'.cmd':''));
}
}else{
(0,_logger.logWarning)("Your "+c.paths.GLOBAL_RNV_CONFIG+" is missing SDK configuration object");
}



if(c.files.GLOBAL_RNV_CONFIG.defaultTargets===undefined){
(0,_logger.logWarning)("Looks like you're missing defaultTargets in your config "+
_chalk.default.white(c.paths.GLOBAL_RNV_CONFIG)+". Let's add them!");

var defaultConfig=JSON.parse(
_fs.default.readFileSync(_path.default.join(c.paths.rnv.dir,'supportFiles','global-config-template.json')).toString());

var newConfig=_objectSpread({},c.files.GLOBAL_RNV_CONFIG,{defaultTargets:defaultConfig.defaultTargets});
_fs.default.writeFileSync(c.paths.GLOBAL_RNV_CONFIG,JSON.stringify(newConfig,null,2));
}
}

resolve();
});};exports.configureRnvGlobal=configureRnvGlobal;