var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.configureNodeModules=exports.cleanNodeModules=exports.copyBuildsFolder=exports.configureEntryPoints=exports.copySharedPlatforms=exports.copyRuntimeAssets=exports.checkAndCreateGitignore=exports.checkAndCreateProjectPackage=void 0;var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _deepmerge=_interopRequireDefault(require("deepmerge"));
var _constants=require("../constants");















































var _common=require("../common");
var _fileutils=require("../systemTools/fileutils");




var _exec=require("../systemTools/exec");
var _logger=require("../systemTools/logger");




var _prompt=require("../systemTools/prompt");
var _pluginTools=require("../pluginTools");
var _configParser=require("../configTools/configParser");


var checkAndCreateProjectPackage=function checkAndCreateProjectPackage(c){return new Promise(function(resolve){
(0,_logger.logTask)('checkAndCreateProjectPackage');

if(!_fs.default.existsSync(c.paths.project.package)){var _c$files$project$conf,_c$files$project$conf2,_c$files$project$conf3;
(0,_logger.logInfo)("Looks like your "+c.paths.project.package+" is missing. Let's create one for you!");

var packageName=c.files.project.config.projectName||c.paths.project.dir.split('/').pop();
var version=((_c$files$project$conf=c.files.project.config.defaults)==null?void 0:(_c$files$project$conf2=_c$files$project$conf.package)==null?void 0:_c$files$project$conf2.version)||'0.1.0';
var templateName=((_c$files$project$conf3=c.files.project.config.defaults)==null?void 0:_c$files$project$conf3.template)||'renative-template-hello-world';
var rnvVersion=c.files.rnv.package.version;

var pkgJson={};
pkgJson.name=packageName;
pkgJson.version=version;
pkgJson.dependencies={
renative:rnvVersion};

pkgJson.devDependencies={
rnv:rnvVersion};

pkgJson.devDependencies[templateName]=rnvVersion;
var pkgJsonStringClean=JSON.stringify(pkgJson,null,2);
_fs.default.writeFileSync(c.paths.project.package,pkgJsonStringClean);
}

(0,_configParser.loadFile)(c.files.project,c.paths.project,'package');

resolve();
});};exports.checkAndCreateProjectPackage=checkAndCreateProjectPackage;

var checkAndCreateGitignore=function checkAndCreateGitignore(c){
(0,_logger.logTask)('checkAndCreateGitignore');
var ignrPath=_path.default.join(c.paths.project.dir,'.gitignore');
if(!_fs.default.existsSync(ignrPath)){
(0,_logger.logInfo)("Looks like your .gitignore is missing. Let's create one for you!");

(0,_fileutils.copyFileSync)(_path.default.join(c.paths.rnv.dir,'supportFiles/gitignore-template'),ignrPath);
}
};exports.checkAndCreateGitignore=checkAndCreateGitignore;

var copyRuntimeAssets=function copyRuntimeAssets(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('copyRuntimeAssets');
var aPath=_path.default.join(c.paths.project.assets.dir,'runtime');
var cPath=_path.default.join(c.paths.appConfig.dir,'assets/runtime');
(0,_fileutils.copyFolderContentsRecursiveSync)(cPath,aPath);





var fontsObj='export default [';

if(c.buildConfig){
if(!c.buildConfig.common){
reject("Your "+_chalk.default.white(c.paths.appConfig.config)+" is missconfigured. (Maybe you have older version?). Missing "+_chalk.default.white('{ common: {} }')+" object at root");
return;
}
if(_fs.default.existsSync(c.paths.project.projectConfig.fontsDir)){
_fs.default.readdirSync(c.paths.project.projectConfig.fontsDir).forEach(function(font){
if(font.includes('.ttf')||font.includes('.otf')){
var key=font.split('.')[0];var
includedFonts=c.buildConfig.common.includedFonts;
if(includedFonts){
if(includedFonts.includes('*')||includedFonts.includes(key)){
if(font){
var fontSource=_path.default.join(c.paths.project.projectConfig.dir,'fonts',font);
if(_fs.default.existsSync(fontSource)){




fontsObj+="{\n                                            fontFamily: '"+
key+"',\n                                            file: require('../../projectConfig/fonts/"+
font+"'),\n                                        },";

}else{
(0,_logger.logWarning)("Font "+_chalk.default.white(fontSource)+" doesn't exist! Skipping.");
}
}
}
}
}
});
}
}

fontsObj+='];';
_fs.default.writeFileSync(_path.default.join(c.paths.project.assets.dir,'runtime','fonts.js'),fontsObj);
var supportFiles=_path.default.resolve(c.paths.rnv.dir,'supportFiles');
(0,_fileutils.copyFileSync)(
_path.default.resolve(supportFiles,'fontManager.js'),
_path.default.resolve(c.paths.project.assets.dir,'runtime','fontManager.js'));

(0,_fileutils.copyFileSync)(
_path.default.resolve(supportFiles,'fontManager.web.js'),
_path.default.resolve(c.paths.project.assets.dir,'runtime','fontManager.web.js'));


resolve();
});};exports.copyRuntimeAssets=copyRuntimeAssets;


var copySharedPlatforms=function copySharedPlatforms(c){return new Promise(function(resolve){
(0,_logger.logTask)("_copySharedPlatform:"+c.platform);

if(c.platform){
(0,_fileutils.mkdirSync)(_path.default.resolve(c.paths.project.platformTemplatesDirs[c.platform],'_shared'));

(0,_fileutils.copyFolderContentsRecursiveSync)(
_path.default.resolve(c.paths.project.platformTemplatesDirs[c.platform],'_shared'),
_path.default.resolve(c.paths.project.builds.dir,'_shared'));

}

resolve();
});};exports.copySharedPlatforms=copySharedPlatforms;

var configureEntryPoints=function configureEntryPoints(c){
(0,_logger.logTask)('configureEntryPoints');







var plat;
var p=c.buildConfig.platforms;
for(var k in p){
plat=p[k];
var source=_path.default.join(c.paths.projectTemplateFolder,plat.entryFile+".js");
var backupSource=_path.default.join(c.paths.rnv.projectTemplate.dir,'entry',plat.entryFile+".js");
var dest=_path.default.join(c.paths.project.dir,plat.entryFile+".js");
if(!_fs.default.existsSync(dest)){
if(!plat.entryFile){
(0,_logger.logError)("You missing entryFile for "+_chalk.default.white(k)+" platform in your "+_chalk.default.white(c.paths.appConfig.config)+".");
}else if(!_fs.default.existsSync(source)){
(0,_logger.logInfo)("You missing entry file "+_chalk.default.white(source)+" in your template. ReNative Will use default backup entry from "+_chalk.default.white(backupSource)+"!");
(0,_fileutils.copyFileSync)(backupSource,dest);
}else{
(0,_logger.logInfo)("You missing entry file "+_chalk.default.white(plat.entryFile)+" in your project. let's create one for you!");
(0,_fileutils.copyFileSync)(source,dest);
}
}
}
};exports.configureEntryPoints=configureEntryPoints;

var copyBuildsFolder=function copyBuildsFolder(c,platform){return new Promise(function(resolve,reject){
(0,_logger.logTask)("copyBuildsFolder:"+platform);
if(!(0,_common.isPlatformActive)(c,platform,resolve))return;

var destPath=_path.default.join((0,_common.getAppFolder)(c,platform));


var sourcePath1=(0,_common.getBuildsFolder)(c,platform,c.paths.project.projectConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath1,destPath);


var sourcePath1sec=(0,_common.getBuildsFolder)(c,platform,c.paths.private.project.projectConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath1sec,destPath);


var sourcePath0=(0,_common.getBuildsFolder)(c,platform,c.paths.appConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath0,destPath,c.paths.appConfig.dir);


var sourcePath0sec=(0,_common.getBuildsFolder)(c,platform,c.paths.private.appConfig.dir);
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath0sec,destPath);

(0,_pluginTools.parsePlugins)(c,platform,function(plugin,pluginPlat,key){

var sourcePath3=(0,_common.getBuildsFolder)(c,platform,_path.default.join(c.paths.project.projectConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath3,destPath);


var sourcePath3sec=(0,_common.getBuildsFolder)(c,platform,_path.default.join(c.paths.private.project.projectConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath3sec,destPath);


var sourcePath2=(0,_common.getBuildsFolder)(c,platform,_path.default.join(c.paths.appConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath2,destPath);


var sourcePath2sec=(0,_common.getBuildsFolder)(c,platform,_path.default.join(c.paths.private.appConfig.dir,"plugins/"+key));
(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath2sec,destPath);
});

resolve();
});};exports.copyBuildsFolder=copyBuildsFolder;

var cleanNodeModules=function cleanNodeModules(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)("cleanNodeModules:"+c.paths.project.nodeModulesDir);
(0,_fileutils.removeDirs)([
_path.default.join(c.paths.project.nodeModulesDir,'react-native-safe-area-view/.git'),
_path.default.join(c.paths.project.nodeModulesDir,'@react-navigation/native/node_modules/react-native-safe-area-view/.git'),
_path.default.join(c.paths.project.nodeModulesDir,'react-navigation/node_modules/react-native-safe-area-view/.git'),
_path.default.join(c.paths.rnv.nodeModulesDir,'react-native-safe-area-view/.git'),
_path.default.join(c.paths.rnv.nodeModulesDir,'@react-navigation/native/node_modules/react-native-safe-area-view/.git'),
_path.default.join(c.paths.rnv.nodeModulesDir,'react-navigation/node_modules/react-native-safe-area-view/.git')]).
then(function(){return resolve();}).catch(function(e){return reject(e);});
});};exports.cleanNodeModules=cleanNodeModules;

var configureNodeModules=function configureNodeModules(c){return new Promise(function(resolve,reject){
(0,_logger.logTask)('configureNodeModules');

if(!_fs.default.existsSync(c.paths.project.nodeModulesDir)||c._requiresNpmInstall){
if(!_fs.default.existsSync(c.paths.project.nodeModulesDir)){
(0,_logger.logWarning)("Looks like your node_modules folder "+
_chalk.default.white(c.paths.project.nodeModulesDir)+" is missing! Let's run "+_chalk.default.white(
'npm install')+" first!");


}else{
(0,_logger.logWarning)("Looks like your node_modules out of date! Let's run "+_chalk.default.white('npm install')+" first!");
}
_npmInstall(c).then(function(){return resolve();}).catch(function(e){return reject(e);});
}else{
resolve();
}
});};exports.configureNodeModules=configureNodeModules;

var _npmInstall=function _npmInstall(c){var failOnError=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;return new Promise(function(resolve,reject){
(0,_logger.logTask)('_npmInstall');
(0,_exec.executeAsync)('npm install').
then(function(){
resolve();
}).
catch(function(e){
if(failOnError){
(0,_logger.logError)(e);
resolve();
}else{
(0,_logger.logWarning)(e+"\n Seems like your node_modules is corrupted by other libs. ReNative will try to fix it for you");
cleanNodeModules(c).
then(function(){return _npmInstall(c,true);}).
then(function(){return resolve();}).
catch(function(e){
(0,_logger.logError)(e);
resolve();
});
}
});
});};