var _interopRequireWildcard=require("@babel/runtime/helpers/interopRequireWildcard");var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.execShellAsync=execShellAsync;exports.default=exports.executeTelnet=exports.openCommand=exports.commandExistsSync=exports.commandExists=exports.execCLI=exports.executeAsync=void 0;var _toConsumableArray2=_interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _path=_interopRequireDefault(require("path"));
var _shelljs=_interopRequireDefault(require("shelljs"));
var _fs=_interopRequireWildcard(require("fs"));
var _chalk=_interopRequireDefault(require("chalk"));
var _execa=_interopRequireDefault(require("execa"));
var _ora=_interopRequireDefault(require("ora"));
var _client=_interopRequireDefault(require("netcat/client"));
var _util=_interopRequireDefault(require("util"));

var _common=require("../common");function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable;});keys.push.apply(keys,symbols);}return keys;}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(source,true).forEach(function(key){(0,_defineProperty2.default)(target,key,source[key]);});}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));}else{ownKeys(source).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key));});}}return target;}var _require=

require('child_process'),exec=_require.exec,execSync=_require.execSync;

var SEPARATOR=process.platform==='win32'?';':':';
var env=(0,_extends2.default)({},process.env);
env.PATH=_path.default.resolve('./node_modules/.bin')+SEPARATOR+env.PATH;

var _execute=function _execute(command){var opts=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};
var defaultOpts={
stdio:'pipe',
localDir:_path.default.resolve('./node_modules/.bin'),
preferLocal:true,
all:true};

var mergedOpts=_objectSpread({},defaultOpts,{},opts);
var cleanCommand=command;

if(Array.isArray(command))cleanCommand=command.join(' ');

var logMessage=cleanCommand;
if(mergedOpts.privateParams){
logMessage=_util.default.format(command,['*******']);
cleanCommand=_util.default.format.apply(_util.default,[command].concat((0,_toConsumableArray2.default)(mergedOpts.privateParams)));
}

(0,_common.logDebug)("_execute: "+logMessage);
var spinner=!mergedOpts.silent&&(0,_ora.default)("Executing: "+logMessage).start();
return _execa.default.command(cleanCommand,mergedOpts).then(function(res){
!mergedOpts.silent&&spinner.succeed();
(0,_common.logDebug)(res.all);

return res.stdout;
}).catch(function(err){var
silent=mergedOpts.silent,ignoreErrors=mergedOpts.ignoreErrors;
if(!silent&&!ignoreErrors)spinner.fail(err.stdout||err.stderr||err.message);
(0,_common.logDebug)(err.all);

if(ignoreErrors){
spinner.succeed();
return true;
}
return Promise.reject(err.stdout||err.stderr||err.message);
});
};

var execCLI=function execCLI(c,cli,command){var opts=arguments.length>3&&arguments[3]!==undefined?arguments[3]:{};
var p=c.cli[cli];

if(!_fs.default.existsSync(p)){
(0,_common.logDebug)('execCLI error',cli,command);
return Promise.reject("Location of your cli "+_chalk.default.white(p)+" does not exists. check your "+_chalk.default.white(
c.paths.globalConfigPath)+" file if you SDK path is correct");

}

return _execute(p+" "+command,_objectSpread({},opts,{shell:true}));
};exports.execCLI=execCLI;

var executeAsync=function executeAsync(cmd,opts){
if(cmd.includes('npm')&&process.platform==='win32')cmd.replace('npm','npm.cmd');
return _execute(cmd,opts);
};exports.executeAsync=executeAsync;

var executeTelnet=function executeTelnet(port,command){return new Promise(function(resolve){
var nc2=new _client.default();
(0,_common.logDebug)("execTelnet: "+port+" "+command);

var output='';

nc2.addr('127.0.0.1').
port(parseInt(port,10)).
connect().
send(command+"\n");
nc2.on('data',function(data){
var resp=Buffer.from(data).toString();
output+=resp;
if(output.includes('OK'))nc2.close();
});
nc2.on('close',function(){return resolve(output);});
});};exports.executeTelnet=executeTelnet;

function execShellAsync(command){
(0,_common.logDebug)('Exec:',command);
return new Promise(function(resolve){
_shelljs.default.exec(command,resolve);
});
}

var isUsingWindows=process.platform==='win32';

var fileNotExists=function fileNotExists(commandName,callback){
(0,_fs.access)(commandName,_fs.constants.F_OK,
function(err){
callback(!err);
});
};

var fileNotExistsSync=function fileNotExistsSync(commandName){
try{
(0,_fs.accessSync)(commandName,_fs.constants.F_OK);
return false;
}catch(e){
return true;
}
};

var localExecutable=function localExecutable(commandName,callback){
(0,_fs.access)(commandName,_fs.constants.F_OK|_fs.constants.X_OK,
function(err){
callback(null,!err);
});
};

var localExecutableSync=function localExecutableSync(commandName){
try{
(0,_fs.accessSync)(commandName,_fs.constants.F_OK|_fs.constants.X_OK);
return true;
}catch(e){
return false;
}
};

var commandExistsUnix=function commandExistsUnix(commandName,cleanedCommandName,callback){
fileNotExists(commandName,function(isFile){
if(!isFile){
exec("command -v "+cleanedCommandName+" 2>/dev/null"+(" && { echo >&1 "+

cleanedCommandName+"; exit 0; }"),
function(error,stdout){
callback(null,!!stdout);
});
return;
}

localExecutable(commandName,callback);
});
};

var commandExistsWindows=function commandExistsWindows(commandName,cleanedCommandName,callback){
if(/[\x00-\x1f<>:"\|\?\*]/.test(commandName)){
callback(null,false);
return;
}
exec("where "+cleanedCommandName,
function(error){
if(error!==null){
callback(null,false);
}else{
callback(null,true);
}
});
};

var commandExistsUnixSync=function commandExistsUnixSync(commandName,cleanedCommandName){
if(fileNotExistsSync(commandName)){
try{
var stdout=execSync("command -v "+cleanedCommandName+" 2>/dev/null"+(" && { echo >&1 "+

cleanedCommandName+"; exit 0; }"));
return!!stdout;
}catch(error){
return false;
}
}
return localExecutableSync(commandName);
};

var commandExistsWindowsSync=function commandExistsWindowsSync(commandName,cleanedCommandName){
if(/[\x00-\x1f<>:"\|\?\*]/.test(commandName)){
return false;
}
try{
var stdout=execSync("where "+cleanedCommandName,{stdio:[]});
return!!stdout;
}catch(error){
return false;
}
};

var cleanInput=function cleanInput(s){
if(/[^A-Za-z0-9_\/:=-]/.test(s)){
s="'"+s.replace(/'/g,"'\\''")+"'";
s=s.replace(/^(?:'')+/g,'').
replace(/\\'''/g,"\\'");
}
return s;
};

if(isUsingWindows){
cleanInput=function cleanInput(s){
var isPathName=/[\\]/.test(s);
if(isPathName){
var dirname="\""+_path.default.dirname(s)+"\"";
var basename="\""+_path.default.basename(s)+"\"";
return dirname+":"+basename;
}
return"\""+s+"\"";
};
}

var commandExists=function commandExists(commandName,callback){
var cleanedCommandName=cleanInput(commandName);
if(!callback&&typeof Promise!=='undefined'){
return new Promise(function(resolve,reject){
commandExists(commandName,function(error,output){
if(output){
resolve(commandName);
}else{
reject(error);
}
});
});
}
if(isUsingWindows){
commandExistsWindows(commandName,cleanedCommandName,callback);
}else{
commandExistsUnix(commandName,cleanedCommandName,callback);
}
};exports.commandExists=commandExists;

var commandExistsSync=function commandExistsSync(commandName){
var cleanedCommandName=cleanInput(commandName);
if(isUsingWindows){
return commandExistsWindowsSync(commandName,cleanedCommandName);
}
return commandExistsUnixSync(commandName,cleanedCommandName);
};exports.commandExistsSync=commandExistsSync;

var openCommand=process.platform=='darwin'?'open':process.platform=='win32'?'start':'xdg-open';exports.openCommand=openCommand;var _default=



{
executeAsync:executeAsync,
execShellAsync:execShellAsync,
execCLI:execCLI,
openCommand:openCommand,
executeTelnet:executeTelnet};exports.default=_default;